using System;
using System.Collections;
using System.Collections.Generic;

using Do.Platform;
using Do.Universe;

using Gnome.Keyring;

namespace Parola
{

	public class Parola
	{
		public Parola ()
		{
			try
			{
				Ring.CreateKeyring("parola-plugin", null);
			}catch{
				// pass
			}

			Ring.SetDefaultKeyring("parola-plugin");
		}

		public IEnumerable<ParolaItem> Find(string query)
		{
			List<Item> parola_items = new List<Item> ();

			Hashtable table = new Hashtable();
			try{
				ItemData[] found_items = Ring.Find(ItemType.GenericSecret, table);

				if (found_items.Length > 0)
				{
					string username = "";
					string account_name = "";
					foreach(ItemData item in found_items)
					{
						username = (string)item.Attributes["username"];
						account_name = (string)item.Attributes["account_name"];

						if (item.Keyring == Ring.GetDefaultKeyring() && 
						    	(username.StartsWith(query) || account_name.StartsWith(query)))
						{
							ParolaItem new_item = new ParolaItem(item.ItemID, username, account_name, item.Secret);
							parola_items.Add(new_item);
						}
					}
				}
			}catch(Exception e){
				System.Console.WriteLine("{0}", e);
			}

			foreach(ParolaItem item in parola_items)
			{
				yield return item;
			}
		}

		public void setClipboardData(string data)
		{
			Gtk.Clipboard.Get(Gdk.Selection.Clipboard).Text = 
				Gtk.Clipboard.Get(Gdk.Selection.Primary).Text = data;
		}
	}
}

